<< LiteRed`

SetDim[d];
Declare[{k1, k2, k3, k4, l1, l2, r1, r2}, Vector, {d, x, Q2, s12, s13, s23}, Number];

job = Get[JOBFILE];
If[job === $Failed, Exit[1]];

job["external-sp-rules"] // Map[Apply[Set]];

Do[
    topo = job["topology-names"][[i]];
    dirname = "litered." <> ToString[topo] <> ".dir";
    If[FileExistsQ[dirname <> "/" <> ToString[topo]],
        Print["* Loading the definitions for ", topo, " from disk"];
        Get[dirname <> "/" <> ToString[topo]];
        (* ExecuteDefinitions[topo]; *)
        Continue[];
    ];
    Print["* NewBasis[", topo, "]"];
    NewBasis[
        topo,
        job["topology-denominators"][[i]],
        job["topology-loop-momenta"],
        Directory -> dirname
    ];
    Print["* GenerateIBP[", topo, "]"];
    GenerateIBP[topo];
    Print["* AnalyzeSectors[", topo, "]"];
    analyzepattern = 
        job["expression"] // 
        Cases[#, j[topo, indices__] :> {indices}, -1] & //
        Union // 
        Map[Map[# <= 0 &]] //
        Transpose //
        Map[Apply[And]] // 
        ReplaceAll[{False -> _, True -> 0}];
    Print["Analyze pattern: ", analyzepattern];
    AnalyzeSectors[topo, analyzepattern(*,CutDs->job["topology-cut-dens"][[i]]*)];
    Print["* FindExtSymmetries[", topo, "]"];
    Print[job["topology-names"] // Take[#, i] & // Reverse];
    job["topology-names"] // Take[#, i] & // Reverse // Apply[FindExtSymmetries];
    Print["* FindSymmetries[", topo, "]"];
    FindSymmetries[topo];
    Print["* SolvejSector[", topo, "]"];
    topo // UniqueSectors // Map[SolvejSector];
    Print["* DiskSave[", topo, "]"];
    DiskSave[topo];
    ,
    {i, job["topology-names"] // Length}
];

job["topology-names"] // Map[(Print["Masters for ", #, ":"]; MIs[#] // Map[Print["- ", #, " = ", # // Fromj] &]) &];

Print["* IBPReduce"];
expr = job["expression"] // IBPReduce;

Print["* Save to ", job["output-file"]];
Put[expr, job["output-file"]];

Print["* Done"];
